From c9806a562f9885cb7a80e90412f5430ecf500a8a Mon Sep 17 00:00:00 2001
From: Jun Xiao <xiaojuntime@gmail.com>
Date: Mon, 23 Sep 2013 05:12:33 -0700
Subject: [PATCH 1/4] Correctly free event related data

Those data need to be freed to avoid memory leak.
---
 libparistraceroute/libparistraceroute/event.c   |    5 +----
 libparistraceroute/libparistraceroute/network.c |    6 ++++--
 2 files changed, 5 insertions(+), 6 deletions(-)

diff --git a/libparistraceroute/libparistraceroute/event.c b/libparistraceroute/libparistraceroute/event.c
index aa4d2f7..21b9b84 100644
--- a/libparistraceroute/libparistraceroute/event.c
+++ b/libparistraceroute/libparistraceroute/event.c
@@ -26,9 +26,6 @@ void event_free(event_t * event)
         if (event->data && event->data_free) {
             event->data_free(event->data);
         }
-        ///////////// TODO
-        //free(event);
-        event->data = NULL; // DEBUG
-        ///////////// TODO
+        free(event);
     }
 }
diff --git a/libparistraceroute/libparistraceroute/network.c b/libparistraceroute/libparistraceroute/network.c
index 56bf2a5..c7627c0 100644
--- a/libparistraceroute/libparistraceroute/network.c
+++ b/libparistraceroute/libparistraceroute/network.c
@@ -637,7 +637,8 @@ bool network_process_recvq(network_t * network)
     probe_reply_set_reply(probe_reply, reply);
 
     // Notify the instance which has build the probe that we've got the corresponding reply
-    pt_algorithm_throw(NULL, probe->caller, event_create(PROBE_REPLY, probe_reply, NULL, NULL)); // TODO probe_reply_free frees only the reply
+    pt_algorithm_throw(NULL, probe->caller,
+        event_create(PROBE_REPLY, probe_reply, NULL, probe_reply_deep_free));
     return true;
 
 ERR_PROBE_REPLY_CREATE:
@@ -674,7 +675,8 @@ bool network_drop_expired_flying_probe(network_t * network)
             if (network_get_probe_timeout(network, probe) - EXTRA_DELAY > 0) break;
 
             // This probe has expired, raise a PROBE_TIMEOUT event.
-            pt_algorithm_throw(NULL, probe->caller, event_create(PROBE_TIMEOUT, probe, NULL, NULL)); //(ELEMENT_FREE) probe_free));
+            pt_algorithm_throw(NULL, probe->caller,
+                event_create(PROBE_TIMEOUT, probe, NULL, probe_free));
         }
 
         // Delete the i oldest probes, which have expired.
-- 
1.7.9.5

